<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/mmi_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p2 { color: #ffffe0; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv0_p2 { color: #add8e6; }
.textRainbow_lv1_o2 { color: #ffffe0; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>07/04/86  mmi_
<span id="L4" class="LineNr">  4 </span>
<span id="L5" class="LineNr">  5 </span>This subroutine primarily provides a means of retrieving information
<span id="L6" class="LineNr">  6 </span>about a data base model <span class="textRainbow_lv0_p0">(</span>Mrds_Model_Interface_<span class="textRainbow_lv0_p0">)</span>.  There is also an
<span id="L7" class="LineNr">  7 </span>entry to create a data base in the same manner as the create_mrds_db
<span id="L8" class="LineNr">  8 </span>command.  This interface replaces dmd_ which is obsolete.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>Entry points in mmi_:
<span id="L12" class="LineNr"> 12 </span>       <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>:Entry:close_model:  07/04/86  mmi_$close_model
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>Function:  This entry closes a given opening of the data base model.
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>Syntax:
<span id="L21" class="LineNr"> 21 </span>declare mmi_$close_model entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L22" class="LineNr"> 22 </span>call mmi_$close_model <span class="textRainbow_lv0_p0">(</span>opening_name<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Arguments:
<span id="L26" class="LineNr"> 26 </span>opening_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L27" class="LineNr"> 27 </span>   is the name given in the call to mmi_$open_model for the opening of
<span id="L28" class="LineNr"> 28 </span>   the model that is to be closed.
<span id="L29" class="LineNr"> 29 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L30" class="LineNr"> 30 </span>   is a standard status code.  If the name given does not refer to a
<span id="L31" class="LineNr"> 31 </span>   current model opening, the code mrds_error_$open_name_not_known will
<span id="L32" class="LineNr"> 32 </span>   be returned.
<span id="L33" class="LineNr"> 33 </span>
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>:Entry:create_db:  07/04/86 mmi_$create_db
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>Function:  This entry provides a go/no-go subroutine interface to
<span id="L38" class="LineNr"> 38 </span>create_mrds_db.
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>Syntax:
<span id="L42" class="LineNr"> 42 </span>declare mmi_$create_db entry options <span class="textRainbow_lv0_p0">(</span>variable<span class="textRainbow_lv0_p0">)</span>;
<span id="L43" class="LineNr"> 43 </span>call mmi_$create_db <span class="textRainbow_lv0_p0">(</span>&quot;source_path&quot;<span class="textRainbow_lv0_o0">,</span> <span class="textRainbow_lv1_p2">{</span>&quot;db_path&quot;<span class="textRainbow_lv1_o2">,</span><span class="textRainbow_lv1_p2">}</span> <span class="textRainbow_lv1_p2">{</span>&quot;-list&quot;<span class="textRainbow_lv1_o2">,</span><span class="textRainbow_lv1_p2">}</span>
<span id="L44" class="LineNr"> 44 </span>   <span class="textRainbow_lv1_p2">{</span>&quot;-secure&quot;<span class="textRainbow_lv1_o2">,</span><span class="textRainbow_lv1_p2">}</span> <span class="textRainbow_lv1_p2">{</span>&quot;-temp_dir&quot;<span class="textRainbow_lv1_o2">,</span> &quot;temp_dir_path&quot;<span class="textRainbow_lv1_o2">,</span><span class="textRainbow_lv1_p2">}</span> <span class="textRainbow_lv1_p2">{</span>&quot;-force&quot;<span class="textRainbow_lv1_p2">}</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>Notes:  where the arguments are the same character string arguments as
<span id="L48" class="LineNr"> 48 </span>given at command level to the create_mrds_db command except that code
<span id="L49" class="LineNr"> 49 </span>must be declared fixed bin<span class="textRainbow_lv0_p0">(</span>35<span class="textRainbow_lv0_p0">)</span>.  The same option and features are
<span id="L50" class="LineNr"> 50 </span>available.  However, the error code of the first error encountered is
<span id="L51" class="LineNr"> 51 </span>returned since it is a go/no-go interface.
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>Since create_mrds_db was written for command level, some of its error
<span id="L55" class="LineNr"> 55 </span>codes do not provide much detail.  Therefore, a listing should be
<span id="L56" class="LineNr"> 56 </span>requested to provide full information.
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>If the -temp_dir <span class="textRainbow_lv0_p2">{</span>path<span class="textRainbow_lv0_p2">}</span> is given, path should be a separate character
<span id="L60" class="LineNr"> 60 </span>string argument from &quot;-temp_dir&quot;.
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>If character variables rather than constants are used in the call to
<span id="L64" class="LineNr"> 64 </span>mmi_$create_db, then trailing blanks should be suppressed <span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> with
<span id="L65" class="LineNr"> 65 </span>the PL/I built-in &quot;rtrim&quot;<span class="textRainbow_lv0_o0">,</span> described in the PL/I Language
<span id="L66" class="LineNr"> 66 </span>Specification<span class="textRainbow_lv0_p0">)</span>.
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>:Entry:get_authorization:  07/04/86  mmi_$get_authorization
<span id="L70" class="LineNr"> 70 </span>
<span id="L71" class="LineNr"> 71 </span>Function:  This entry returns the user class of the caller for a given
<span id="L72" class="LineNr"> 72 </span>data base.
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>Syntax:
<span id="L76" class="LineNr"> 76 </span>declare mmi_$get_authorization entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L77" class="LineNr"> 77 </span>   fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L78" class="LineNr"> 78 </span>call mmi_$get_authorization <span class="textRainbow_lv0_p0">(</span>database_path<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L79" class="LineNr"> 79 </span>   structure_version<span class="textRainbow_lv0_o0">,</span> mrds_authorization_ptr<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>
<span id="L82" class="LineNr"> 82 </span>Arguments:
<span id="L83" class="LineNr"> 83 </span>database_path <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L84" class="LineNr"> 84 </span>   is the relative or absolute pathname of the data base, with or
<span id="L85" class="LineNr"> 85 </span>   without the .db suffix.  This path must refer to a version 4 data
<span id="L86" class="LineNr"> 86 </span>   base.
<span id="L87" class="LineNr"> 87 </span>area_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L88" class="LineNr"> 88 </span>   is a pointer to a freeing area supplied by the caller in which the
<span id="L89" class="LineNr"> 89 </span>   mrds_authorization structure is to be allocated.
<span id="L90" class="LineNr"> 90 </span>structure_version <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>
<span id="L91" class="LineNr"> 91 </span>   is the desired structure version the user wishes to have returned.
<span id="L92" class="LineNr"> 92 </span>mrds_authorization_ptr <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L93" class="LineNr"> 93 </span>   is a pointer to the allocated structure.  This structure is
<span id="L94" class="LineNr"> 94 </span>   described in the Notes below.
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L98" class="LineNr"> 98 </span>   is a standard status code.  It may be one of the following;
<span id="L99" class="LineNr"> 99 </span>   error_table_$area_too_small
<span id="L100" class="LineNr">100 </span>      if the supplied area could not contain the mrds_authorization
<span id="L101" class="LineNr">101 </span>      structure.
<span id="L102" class="LineNr">102 </span>   error_table_$badcall
<span id="L103" class="LineNr">103 </span>      if the area_ptr was null.
<span id="L104" class="LineNr">104 </span>   mrds_error_$no_data base
<span id="L105" class="LineNr">105 </span>      if the given path does not refer to a MRDS data base.
<span id="L106" class="LineNr">106 </span>   mrds_error_$not_freeing_area
<span id="L107" class="LineNr">107 </span>      if the supplied area does not have the attribute &quot;freeing&quot;.
<span id="L108" class="LineNr">108 </span>   error_table_$unimplemented_version
<span id="L109" class="LineNr">109 </span>      if the given structure version is unknown.
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>   mrds_error_$version_not_supported
<span id="L113" class="LineNr">113 </span>      if the data base path does not refer to a version 4 MRDS data
<span id="L114" class="LineNr">114 </span>      base.
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>Notes:  The user class information for the specified data base is
<span id="L118" class="LineNr">118 </span>returned in the following structure;
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>declare 1 mrds_authorization aligned
<span id="L121" class="LineNr">121 </span>          based <span class="textRainbow_lv0_p0">(</span>mrds_authorization_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L122" class="LineNr">122 </span>        2 version fixed bin,
<span id="L123" class="LineNr">123 </span>        2 administrator bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L124" class="LineNr">124 </span>        2 normal_user bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L125" class="LineNr">125 </span>        2 mbz bit<span class="textRainbow_lv0_p0">(</span>34<span class="textRainbow_lv0_p0">)</span> unal;
<span id="L126" class="LineNr">126 </span>
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>:Entry:get_model_attributes:  07/04/86  mmi_$get_model_attributes
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>Function:  This entry returns attribute information for a particular
<span id="L131" class="LineNr">131 </span>relation in the data base model.
<span id="L132" class="LineNr">132 </span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>Syntax:
<span id="L135" class="LineNr">135 </span>declare mmi_$get_model_attributes entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L136" class="LineNr">136 </span>   fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L137" class="LineNr">137 </span>call mmi_$get_model_attributes <span class="textRainbow_lv0_p0">(</span>opening_name<span class="textRainbow_lv0_o0">,</span> relation_name<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L138" class="LineNr">138 </span>   structure_version<span class="textRainbow_lv0_o0">,</span> mrds_db_model_rel_attrs_ptr<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Arguments:
<span id="L142" class="LineNr">142 </span>opening_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L143" class="LineNr">143 </span>   is the name used in the call to mmi_$open_model.
<span id="L144" class="LineNr">144 </span>relation_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L145" class="LineNr">145 </span>   is the name of the relation for which the attribute information is
<span id="L146" class="LineNr">146 </span>   desired.
<span id="L147" class="LineNr">147 </span>area_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L148" class="LineNr">148 </span>   is a pointer to a user-supplied freeing area in which the attribute
<span id="L149" class="LineNr">149 </span>   information will be allocated.
<span id="L150" class="LineNr">150 </span>structure_version <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>
<span id="L151" class="LineNr">151 </span>   is the desired version of the attribute information structure to be
<span id="L152" class="LineNr">152 </span>   allocated.
<span id="L153" class="LineNr">153 </span>mrds_db_model_rel_attrs_ptr <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L154" class="LineNr">154 </span>   is a pointer to the allocated attribute information structure
<span id="L155" class="LineNr">155 </span>   described in the Notes below.
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L159" class="LineNr">159 </span>   is the standard status code.  It may be one of the following:
<span id="L160" class="LineNr">160 </span>   error_table_$area_too_small
<span id="L161" class="LineNr">161 </span>      if the supplied area could not hold the attribute information
<span id="L162" class="LineNr">162 </span>      structure.
<span id="L163" class="LineNr">163 </span>   error_table_$badcall
<span id="L164" class="LineNr">164 </span>      if the area_ptr was null.
<span id="L165" class="LineNr">165 </span>   error_table_$unimplemented_version
<span id="L166" class="LineNr">166 </span>      if the structure version given was unknown.
<span id="L167" class="LineNr">167 </span>   mrds_error_$no_model_access
<span id="L168" class="LineNr">168 </span>      if the user does not have &quot;r&quot; access to the relation model
<span id="L169" class="LineNr">169 </span>      segment for the given relation.
<span id="L170" class="LineNr">170 </span>   mrds_error_$no_model_rel
<span id="L171" class="LineNr">171 </span>      if the relation name given is not in the model definition.
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>
<span id="L174" class="LineNr">174 </span>   mrds_error_$not_freeing_area
<span id="L175" class="LineNr">175 </span>      if the supplied area does not have the attribute &quot;freeing&quot;.
<span id="L176" class="LineNr">176 </span>   mrds_error_$open_name_not_known
<span id="L177" class="LineNr">177 </span>      if the name given does not refer to a current model opening.
<span id="L178" class="LineNr">178 </span>
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>Notes:  The attribute information is returned in the following
<span id="L181" class="LineNr">181 </span>structure:
<span id="L182" class="LineNr">182 </span>declare 1 mrds_db_model_rel_attrs aligned
<span id="L183" class="LineNr">183 </span>          based <span class="textRainbow_lv0_p0">(</span>mrds_db_model_rel_attrs_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L184" class="LineNr">184 </span>        2 version fixed bin,
<span id="L185" class="LineNr">185 </span>        2 attribute_count fixed bin,
<span id="L186" class="LineNr">186 </span>        2 mbz1 bit<span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L187" class="LineNr">187 </span>        2 attribute <span class="textRainbow_lv0_p0">(</span>0
<span id="L188" class="LineNr">188 </span>          refer <span class="textRainbow_lv1_p0">(</span>mrds_db_model_rel_attrs.attribute_count<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>,
<span id="L189" class="LineNr">189 </span>          3 name char<span class="textRainbow_lv0_p0">(</span>32<span class="textRainbow_lv0_p0">)</span>,
<span id="L190" class="LineNr">190 </span>          3 domain char<span class="textRainbow_lv0_p0">(</span>32<span class="textRainbow_lv0_p0">)</span>,
<span id="L191" class="LineNr">191 </span>          3 user_data_type bit<span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span>,
<span id="L192" class="LineNr">192 </span>          3 indexed bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L193" class="LineNr">193 </span>          3 mbz2 bit<span class="textRainbow_lv0_p0">(</span>35<span class="textRainbow_lv0_p0">)</span> unal;
<span id="L194" class="LineNr">194 </span>
<span id="L195" class="LineNr">195 </span>
<span id="L196" class="LineNr">196 </span>If the data base is secured, this interface is only usable by a DBA.
<span id="L197" class="LineNr">197 </span>If the data base is not secured, the user must have &quot;r&quot; access to the
<span id="L198" class="LineNr">198 </span>model segment for the relation involved.
<span id="L199" class="LineNr">199 </span>
<span id="L200" class="LineNr">200 </span>
<span id="L201" class="LineNr">201 </span>:Entry:get_model_info:  07/04/86  mmi_$get_model_info
<span id="L202" class="LineNr">202 </span>
<span id="L203" class="LineNr">203 </span>Function:  This entry returns information about the data base model
<span id="L204" class="LineNr">204 </span>creation.
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>
<span id="L207" class="LineNr">207 </span>Syntax:
<span id="L208" class="LineNr">208 </span>declare mmi_$get_model_info entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L209" class="LineNr">209 </span>   fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L210" class="LineNr">210 </span>call mmi_$get_model_info <span class="textRainbow_lv0_p0">(</span>opening_name<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span> structure_version<span class="textRainbow_lv0_o0">,</span>
<span id="L211" class="LineNr">211 </span>   mrds_db_model_info_ptr<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L212" class="LineNr">212 </span>
<span id="L213" class="LineNr">213 </span>
<span id="L214" class="LineNr">214 </span>Arguments:
<span id="L215" class="LineNr">215 </span>opening_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L216" class="LineNr">216 </span>   is the name used in the call to mmi_$open_model.
<span id="L217" class="LineNr">217 </span>area_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L218" class="LineNr">218 </span>   is a pointer to a user-supplied freeing area in which the model
<span id="L219" class="LineNr">219 </span>   information will be allocated.
<span id="L220" class="LineNr">220 </span>structure_version <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>
<span id="L221" class="LineNr">221 </span>   is the desired structure version of the model information.
<span id="L222" class="LineNr">222 </span>mrds_db_model_info_ptr <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L223" class="LineNr">223 </span>   the pointer to the allocated model information structure as
<span id="L224" class="LineNr">224 </span>   described in the Notes below.
<span id="L225" class="LineNr">225 </span>
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L228" class="LineNr">228 </span>   is the standard status code.  It may be one of the following:
<span id="L229" class="LineNr">229 </span>   error_table_$area_too_small
<span id="L230" class="LineNr">230 </span>      if the area could not hold the model information structure.
<span id="L231" class="LineNr">231 </span>   error_table_$badcall
<span id="L232" class="LineNr">232 </span>      if the area_ptr was null.
<span id="L233" class="LineNr">233 </span>   error_table_$unimplemented_version
<span id="L234" class="LineNr">234 </span>      if the supplied structure version is unknown.
<span id="L235" class="LineNr">235 </span>   mrds_error_$no_model_access
<span id="L236" class="LineNr">236 </span>      if the user does not have &quot;r&quot; access to the db_model segment.
<span id="L237" class="LineNr">237 </span>   mrds_error_$not_freeing_area
<span id="L238" class="LineNr">238 </span>      if the supplied area does not have the attribute &quot;freeing&quot;.
<span id="L239" class="LineNr">239 </span>   mrds_error_$open_name_not_known
<span id="L240" class="LineNr">240 </span>      if the opening_name does not refer to a current model opening.
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span>
<span id="L243" class="LineNr">243 </span>Notes:  The model information is returned in the following structure:
<span id="L244" class="LineNr">244 </span>declare 1 mrds_db_model_info aligned,
<span id="L245" class="LineNr">245 </span>        2 version fixed bin,
<span id="L246" class="LineNr">246 </span>        2 model_version fixed bin,
<span id="L247" class="LineNr">247 </span>        2 db_type fixed bin,
<span id="L248" class="LineNr">248 </span>        2 dmfile_ attributes,
<span id="L249" class="LineNr">249 </span>          3 protected bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L250" class="LineNr">250 </span>          3 rollback bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L251" class="LineNr">251 </span>          3 concurrency bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L252" class="LineNr">252 </span>          3 mbz bit<span class="textRainbow_lv0_p0">(</span>33<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L253" class="LineNr">253 </span>        2 creator_id char<span class="textRainbow_lv0_p0">(</span>32<span class="textRainbow_lv0_p0">)</span>,
<span id="L254" class="LineNr">254 </span>        2 creation_time fixed bin<span class="textRainbow_lv0_p0">(</span>71<span class="textRainbow_lv0_p0">)</span>;
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>
<span id="L257" class="LineNr">257 </span>The latest version of the structure is version 2.  Programs using the
<span id="L258" class="LineNr">258 </span>version 1 structure will continue to execute correctly.
<span id="L259" class="LineNr">259 </span>
<span id="L260" class="LineNr">260 </span>
<span id="L261" class="LineNr">261 </span>If the data base is secured, this interface is only usable by a DBA.
<span id="L262" class="LineNr">262 </span>If the data base is not secured, the user must have &quot;r&quot; access to the
<span id="L263" class="LineNr">263 </span>db_model segment under the data base directory.
<span id="L264" class="LineNr">264 </span>
<span id="L265" class="LineNr">265 </span>
<span id="L266" class="LineNr">266 </span>:Entry:get_model_relations:  07/04/86  mmi_$get_model_relations
<span id="L267" class="LineNr">267 </span>
<span id="L268" class="LineNr">268 </span>Function:  This entry returns information about all the relations in
<span id="L269" class="LineNr">269 </span>the given model opening.
<span id="L270" class="LineNr">270 </span>
<span id="L271" class="LineNr">271 </span>
<span id="L272" class="LineNr">272 </span>Syntax:
<span id="L273" class="LineNr">273 </span>declare mmi_$get_model_relations entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L274" class="LineNr">274 </span>   fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L275" class="LineNr">275 </span>call mmi_$get_model_relations <span class="textRainbow_lv0_p0">(</span>opening_name<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L276" class="LineNr">276 </span>   structure_version<span class="textRainbow_lv0_o0">,</span> mrds_db_model_relations_ptr<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L277" class="LineNr">277 </span>
<span id="L278" class="LineNr">278 </span>
<span id="L279" class="LineNr">279 </span>Arguments:
<span id="L280" class="LineNr">280 </span>opening_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L281" class="LineNr">281 </span>   is the name used in the call to mmi_$open_model.
<span id="L282" class="LineNr">282 </span>area_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L283" class="LineNr">283 </span>   is a pointer to a user-supplied freeing area in which the relation
<span id="L284" class="LineNr">284 </span>   information will be allocated.
<span id="L285" class="LineNr">285 </span>structure_version <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>
<span id="L286" class="LineNr">286 </span>   is the desired structure version of the relation information.
<span id="L287" class="LineNr">287 </span>mrds_db_model_relations_ptr <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L288" class="LineNr">288 </span>   is the pointer to the allocated structure of relation information in
<span id="L289" class="LineNr">289 </span>   the form described in Notes below.
<span id="L290" class="LineNr">290 </span>
<span id="L291" class="LineNr">291 </span>
<span id="L292" class="LineNr">292 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L293" class="LineNr">293 </span>   is the standard status code.  It may be one of the following:
<span id="L294" class="LineNr">294 </span>   error_table_$area_too_small
<span id="L295" class="LineNr">295 </span>      if the area could not hold the relation information.
<span id="L296" class="LineNr">296 </span>   error_table_$badcall
<span id="L297" class="LineNr">297 </span>      if the area_ptr was null.
<span id="L298" class="LineNr">298 </span>   error_table_$unimplemented_version
<span id="L299" class="LineNr">299 </span>      if the given structure version is unknown.
<span id="L300" class="LineNr">300 </span>   mrds_error_$no_model_access
<span id="L301" class="LineNr">301 </span>      if the user does not have &quot;r&quot; access to the db_model segment.
<span id="L302" class="LineNr">302 </span>   mrds_error_$not_freeing_area
<span id="L303" class="LineNr">303 </span>      if the supplied area does not have the attribute &quot;freeing&quot;.
<span id="L304" class="LineNr">304 </span>   mrds_error_$open_name_not_known
<span id="L305" class="LineNr">305 </span>      if the opening_name does not refer to a current model opening.
<span id="L306" class="LineNr">306 </span>
<span id="L307" class="LineNr">307 </span>
<span id="L308" class="LineNr">308 </span>Notes:  The relation information is returned in the following
<span id="L309" class="LineNr">309 </span>structure:
<span id="L310" class="LineNr">310 </span>declare 1 mrds_db_model_relations aligned
<span id="L311" class="LineNr">311 </span>          based <span class="textRainbow_lv0_p0">(</span>mrds_db_model_relations_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L312" class="LineNr">312 </span>        2 version,
<span id="L313" class="LineNr">313 </span>        2 relation_count fixed bin,
<span id="L314" class="LineNr">314 </span>        2 mbz1 bit<span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L315" class="LineNr">315 </span>        2 relation <span class="textRainbow_lv0_p0">(</span>0
<span id="L316" class="LineNr">316 </span>          refer <span class="textRainbow_lv1_p0">(</span>mrds_db_model_relations.relation_count<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>,
<span id="L317" class="LineNr">317 </span>          3 name char<span class="textRainbow_lv0_p0">(</span>32<span class="textRainbow_lv0_p0">)</span>,
<span id="L318" class="LineNr">318 </span>          3 mbz2 bit<span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span> unal;
<span id="L319" class="LineNr">319 </span>
<span id="L320" class="LineNr">320 </span>
<span id="L321" class="LineNr">321 </span>Currently, the only structure version available is 1.
<span id="L322" class="LineNr">322 </span>
<span id="L323" class="LineNr">323 </span>
<span id="L324" class="LineNr">324 </span>If the  data base is secured, this  interface is usable only by  a DBA.  If
<span id="L325" class="LineNr">325 </span>the  data base is  not secured, the  user must have  &quot;r&quot; access to  the
<span id="L326" class="LineNr">326 </span>db_model segment under the data base directory.
<span id="L327" class="LineNr">327 </span>
<span id="L328" class="LineNr">328 </span>
<span id="L329" class="LineNr">329 </span>:Entry:get_secured_state:  07/04/86  mmi_$get_secured_state
<span id="L330" class="LineNr">330 </span>
<span id="L331" class="LineNr">331 </span>Function:  This entry returns the secured state of the given data base.
<span id="L332" class="LineNr">332 </span>
<span id="L333" class="LineNr">333 </span>
<span id="L334" class="LineNr">334 </span>Syntax:
<span id="L335" class="LineNr">335 </span>declare mmi_$get_secured_state entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L336" class="LineNr">336 </span>   ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L337" class="LineNr">337 </span>call mmi_$get_secured_state <span class="textRainbow_lv0_p0">(</span>database_path<span class="textRainbow_lv0_o0">,</span> area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L338" class="LineNr">338 </span>   structure_version<span class="textRainbow_lv0_o0">,</span> database_state_ptr<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L339" class="LineNr">339 </span>
<span id="L340" class="LineNr">340 </span>
<span id="L341" class="LineNr">341 </span>Arguments:
<span id="L342" class="LineNr">342 </span>database_path <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L343" class="LineNr">343 </span>   is the relative or absolute pathname of the data base whose secured
<span id="L344" class="LineNr">344 </span>   state is desired.  It must refer to a version 4 data base.  The
<span id="L345" class="LineNr">345 </span>   suffix need not be present.
<span id="L346" class="LineNr">346 </span>area_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L347" class="LineNr">347 </span>   is a pointer to a user-supplied freeing area in which the data base
<span id="L348" class="LineNr">348 </span>   state information will be allocated.
<span id="L349" class="LineNr">349 </span>structure_version <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>
<span id="L350" class="LineNr">350 </span>   is the desired version of the structure containing data base state
<span id="L351" class="LineNr">351 </span>   information.
<span id="L352" class="LineNr">352 </span>database_state_ptr <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_p0">)</span>
<span id="L353" class="LineNr">353 </span>   the pointer to the allocated data base state information as
<span id="L354" class="LineNr">354 </span>   contained in the structure described in the Notes below.
<span id="L355" class="LineNr">355 </span>
<span id="L356" class="LineNr">356 </span>
<span id="L357" class="LineNr">357 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L358" class="LineNr">358 </span>   is the standard status code.  It may be one of the following:
<span id="L359" class="LineNr">359 </span>   error_table_$area_too_small
<span id="L360" class="LineNr">360 </span>      if the supplied area could not hold the data base state
<span id="L361" class="LineNr">361 </span>      information.
<span id="L362" class="LineNr">362 </span>   error_table_$badcall
<span id="L363" class="LineNr">363 </span>      if the area_ptr was null.
<span id="L364" class="LineNr">364 </span>   error_table_$insufficient_access
<span id="L365" class="LineNr">365 </span>      if the user has no access to both the data base directory and the
<span id="L366" class="LineNr">366 </span>      db_model segment.
<span id="L367" class="LineNr">367 </span>   error_table_$unimplemented_version
<span id="L368" class="LineNr">368 </span>      if the supplied structure version is unknown.
<span id="L369" class="LineNr">369 </span>   mrds_error_$no_data base
<span id="L370" class="LineNr">370 </span>      if the given path does not refer to a MRDS data base.
<span id="L371" class="LineNr">371 </span>
<span id="L372" class="LineNr">372 </span>
<span id="L373" class="LineNr">373 </span>   mrds_error_$no_model_access
<span id="L374" class="LineNr">374 </span>      if the user does not have &quot;r&quot; access to the data base db_model
<span id="L375" class="LineNr">375 </span>      segment.
<span id="L376" class="LineNr">376 </span>   mrds_error_$not_freeing_area
<span id="L377" class="LineNr">377 </span>      if the supplied area does not have the attribute &quot;freeing&quot;.
<span id="L378" class="LineNr">378 </span>   mrds_error_$version_not_supported
<span id="L379" class="LineNr">379 </span>      if the path given is to a data base whose version is less than 4.
<span id="L380" class="LineNr">380 </span>
<span id="L381" class="LineNr">381 </span>
<span id="L382" class="LineNr">382 </span>Notes The data base state information is returned in the following
<span id="L383" class="LineNr">383 </span>structure:
<span id="L384" class="LineNr">384 </span>declare 1 database_state aligned
<span id="L385" class="LineNr">385 </span>          based <span class="textRainbow_lv0_p0">(</span>database_state_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L386" class="LineNr">386 </span>        2 version fixed bin,
<span id="L387" class="LineNr">387 </span>        2 unsecured bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L388" class="LineNr">388 </span>        2 secured bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L389" class="LineNr">389 </span>        2 mbz bit<span class="textRainbow_lv0_p0">(</span>34<span class="textRainbow_lv0_p0">)</span> unal;
<span id="L390" class="LineNr">390 </span>
<span id="L391" class="LineNr">391 </span>
<span id="L392" class="LineNr">392 </span>Currently, the only structure version available is one.
<span id="L393" class="LineNr">393 </span>
<span id="L394" class="LineNr">394 </span>
<span id="L395" class="LineNr">395 </span>:Entry:open_model:  07/04/86  mmi_$open_model
<span id="L396" class="LineNr">396 </span>
<span id="L397" class="LineNr">397 </span>Function:  This entry opens the data base model for retrieving
<span id="L398" class="LineNr">398 </span>information about relations, attributes, and creation of the model.
<span id="L399" class="LineNr">399 </span>There may be multiple openings of the same data base model or different
<span id="L400" class="LineNr">400 </span>data base models.
<span id="L401" class="LineNr">401 </span>
<span id="L402" class="LineNr">402 </span>
<span id="L403" class="LineNr">403 </span>Syntax:
<span id="L404" class="LineNr">404 </span>declare mmi_$open_model entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L405" class="LineNr">405 </span>call mmi_$open_model <span class="textRainbow_lv0_p0">(</span>database_path<span class="textRainbow_lv0_o0">,</span> opening_name<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L406" class="LineNr">406 </span>
<span id="L407" class="LineNr">407 </span>
<span id="L408" class="LineNr">408 </span>Arguments:
<span id="L409" class="LineNr">409 </span>database_path <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L410" class="LineNr">410 </span>     is the relative or absolute pathname of the data base, whose data
<span id="L411" class="LineNr">411 </span>     model is to be opened.  Version 4 data bases need not have the .db
<span id="L412" class="LineNr">412 </span>     suffix supplied.
<span id="L413" class="LineNr">413 </span>opening_name <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L414" class="LineNr">414 </span>     a user-supplied name, to be used in other mmi_ calls referencing
<span id="L415" class="LineNr">415 </span>     this opening when obtaining model information.
<span id="L416" class="LineNr">416 </span>
<span id="L417" class="LineNr">417 </span>
<span id="L418" class="LineNr">418 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L419" class="LineNr">419 </span>     is the standard status code.  It may be one of the following:
<span id="L420" class="LineNr">420 </span>   error_table_$insufficient_access
<span id="L421" class="LineNr">421 </span>        if the data base has been secured and the user is not a DBA.
<span id="L422" class="LineNr">422 </span>   mrds_error_$no_database
<span id="L423" class="LineNr">423 </span>        if no data base exists at the given pathname.
<span id="L424" class="LineNr">424 </span>   mrds_error_$no_model_access
<span id="L425" class="LineNr">425 </span>        if the user does not have &quot;r&quot; access to the data base model
<span id="L426" class="LineNr">426 </span>        segment.
<span id="L427" class="LineNr">427 </span>   mrds_error_$open_name_already_known
<span id="L428" class="LineNr">428 </span>        if the opening_name supplied was not unique, within PL/I
<span id="L429" class="LineNr">429 </span>        comparison rules, compared to other opening names already used
<span id="L430" class="LineNr">430 </span>        in the user's process.
<span id="L431" class="LineNr">431 </span>
<span id="L432" class="LineNr">432 </span>
<span id="L433" class="LineNr">433 </span>   mrds_error_$too_many_open_names
<span id="L434" class="LineNr">434 </span>        if the combined lengths and number of opening_names used in the
<span id="L435" class="LineNr">435 </span>        user's process exceeded the storage capability of the open name
<span id="L436" class="LineNr">436 </span>        manager.
<span id="L437" class="LineNr">437 </span>
<span id="L438" class="LineNr">438 </span>
<span id="L439" class="LineNr">439 </span>Notes:  The opening_name may be any number of ASCII characters.
<span id="L440" class="LineNr">440 </span>Current capability is for more than 1000 opening_names of reasonable
<span id="L441" class="LineNr">441 </span>length for version 4 models, but only 64 for models of version 3.
<span id="L442" class="LineNr">442 </span>Opening_names must be unique to PL/I comparison rules within the user's
<span id="L443" class="LineNr">443 </span>process.  <span class="textRainbow_lv0_p0">(</span>The entry unique_chars_<span class="textRainbow_lv0_o0">,</span> described in MPM Subroutines<span class="textRainbow_lv0_o0">,</span> can
<span id="L444" class="LineNr">444 </span>be used to generate unique names.<span class="textRainbow_lv0_p0">)</span>
<span id="L445" class="LineNr">445 </span>
<span id="L446" class="LineNr">446 </span>
<span id="L447" class="LineNr">447 </span>If the data base is secured, this interface is only usable by a DBA.
<span id="L448" class="LineNr">448 </span>If the data base is not secured, the user must have at least &quot;r&quot; access
<span id="L449" class="LineNr">449 </span>to the db_model segment under the data base directory.
<span id="L450" class="LineNr">450 </span>
<span id="L451" class="LineNr">451 </span>
<span id="L452" class="LineNr">452 </span>:Entry:quiesce_db:  07/04/86  mmi_$quiesce_db
<span id="L453" class="LineNr">453 </span>
<span id="L454" class="LineNr">454 </span>Function:  This entry allows the DBA to quiesce a given data base for
<span id="L455" class="LineNr">455 </span>such purposes as data base backup or other exclusive activities that
<span id="L456" class="LineNr">456 </span>require a consistent and non-active data base.  The data base can be
<span id="L457" class="LineNr">457 </span>returned to a non-quiescent state by use of the mmi_$unquiesce_db
<span id="L458" class="LineNr">458 </span>entrypoint.
<span id="L459" class="LineNr">459 </span>
<span id="L460" class="LineNr">460 </span>
<span id="L461" class="LineNr">461 </span>Syntax:
<span id="L462" class="LineNr">462 </span>declare mmi_$quiesce_db entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L463" class="LineNr">463 </span>call mmi_$quiesce_db <span class="textRainbow_lv0_p0">(</span>database_path<span class="textRainbow_lv0_o0">,</span> wait_time<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L464" class="LineNr">464 </span>
<span id="L465" class="LineNr">465 </span>
<span id="L466" class="LineNr">466 </span>Arguments:
<span id="L467" class="LineNr">467 </span>database_path        <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L468" class="LineNr">468 </span>   is the relative or absolute pathname of the data base to be
<span id="L469" class="LineNr">469 </span>   quiesced.  Version 4 data bases need not have the db suffix
<span id="L470" class="LineNr">470 </span>   supplied.
<span id="L471" class="LineNr">471 </span>wait_time <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L472" class="LineNr">472 </span>   sets the amount of time that an attempt to quiesce waits for
<span id="L473" class="LineNr">473 </span>   conflicting data base users to depart before failing <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot;<span class="textRainbow_lv0_p0">)</span>.
<span id="L474" class="LineNr">474 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L475" class="LineNr">475 </span>   is the standard status code.
<span id="L476" class="LineNr">476 </span>
<span id="L477" class="LineNr">477 </span>
<span id="L478" class="LineNr">478 </span>Notes:  Time specified for wait_time is in seconds.  A long wait is
<span id="L479" class="LineNr">479 </span>needed if the data base is open by many users; otherwise, a short
<span id="L480" class="LineNr">480 </span>wait_time will suffice.  For a simple go/nogo test, give a wait_time of
<span id="L481" class="LineNr">481 </span>1 second.
<span id="L482" class="LineNr">482 </span>
<span id="L483" class="LineNr">483 </span>
<span id="L484" class="LineNr">484 </span>:Entry:unquiesce_db:  07/04/86  mmi_$unquiesce_db
<span id="L485" class="LineNr">485 </span>
<span id="L486" class="LineNr">486 </span>Function:  This entry returns a data base that is in a quiescent state
<span id="L487" class="LineNr">487 </span><span class="textRainbow_lv0_p0">(</span>by either mmi_$quiesce_db or the quiesce_mrds_db command<span class="textRainbow_lv0_p0">)</span> to a
<span id="L488" class="LineNr">488 </span>non-quiescent state.
<span id="L489" class="LineNr">489 </span>
<span id="L490" class="LineNr">490 </span>
<span id="L491" class="LineNr">491 </span>Syntax:
<span id="L492" class="LineNr">492 </span>declare mmi_$unquiesce_db entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L493" class="LineNr">493 </span>call mmi_$unquiesce_db <span class="textRainbow_lv0_p0">(</span>database_path<span class="textRainbow_lv0_o0">,</span> error_code<span class="textRainbow_lv0_p0">)</span>;
<span id="L494" class="LineNr">494 </span>
<span id="L495" class="LineNr">495 </span>
<span id="L496" class="LineNr">496 </span>Arguments:
<span id="L497" class="LineNr">497 </span>database_path <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L498" class="LineNr">498 </span>   is the relative or absolute pathname of the data base to be freed.
<span id="L499" class="LineNr">499 </span>   Version 4 data bases need not have the db suffix supplied.
<span id="L500" class="LineNr">500 </span>error_code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L501" class="LineNr">501 </span>   is the standard status code.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
